import matplotlib

import numpy as np
matplotlib.use('TkAgg')
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg, NavigationToolbar2TkAgg
import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, RadioButtons

import time
import random
import sys
from Tkinter import *
import spidev
import matplotlib.animation as animation
import matplotlib.pyplot as plt

import spidev

spi = spidev.SpiDev()
spi.open(0,0)
spi.mode = 0
spi.max_speed_hz = 20000000

xmax = 7.5
ymax = 4
interval_ms = 1
saveIndex = 0

frequency = 200
amplitude = .5
fig = plt.figure()
ax1 = plt.axes(xlim = (0, xmax), ylim = (0, ymax))
line, = ax1.plot([], [], lw=1)

#Set up figures and axes
#fig, ax = plt.subplots()
txt = plt.figtext(0.5,0.8,'initial')
#ax.set_xlim([0, data_width]) #can this be xmax?
#ax.set_ylim([0, ymax])
#fig.canvas = FigureCanvasTkAgg(fig, master=window)
#fig.canvas.show()
#fig.canvas.get_tk_widget().pack(side=TOP, fill=BOTH, expand=1)
#fig.canvas._tkcanvas.pack(side=TOP, fill=BOTH, expand=1)
plt.subplots_adjust(bottom=0.5)

#Sliders and radios
axcolor = 'lightgoldenrodyellow'
axXmax = plt.axes([0.2, 0.4, 0.65, 0.03], axisbg=axcolor)
axYmax = plt.axes([0.2, 0.35, 0.65, 0.03], axisbg=axcolor)

global xMaxSlider
global yMaxSlider

oscilGenText = plt.text(1.75,19.25,'PICBerry')
oscilGenText.set_size(20)
    
xMaxSlider = Slider(axXmax, 'Zoom:', 0, 100, valinit=0)
yMaxSlider = Slider(axYmax, 'Y Max:', .1, 5, valinit=ymax)


axYmax.text(-.5, -2, 'Function Generation:', color='black')

rax = plt.axes([0.15, .1, 0.15, 0.15], axisbg=axcolor)
global radio
radio = RadioButtons(rax, ('Sine', 'Square', 'Sawtooth'))

global saveButton
rax2 = plt.axes([0, .1, 0.15, 0.15],axisbg=axcolor)
saveButton = RadioButtons(rax2, ('No Save', 'Save'))

freq = plt.axes([.4, 0.2, 0.4, 0.03], axisbg=axcolor)
amp = plt.axes([.4, 0.15, 0.4, 0.03], axisbg=axcolor)
    
global freqSlider
global ampSlider
freqSlider = Slider(freq, 'Freq:', 1, 2000, valinit=frequency)
ampSlider = Slider(amp, 'Amp:', 0, 1, valinit=amplitude)

numSamples = 600
xIncrement = .025
dropPacketConst = 5
ax1.get_xaxis().set_visible(False)

# ax1.add_artist(line)

# fig.show()
# fig.canvas.draw()

xar = []
yar = []
line.set_data(xar, yar)

def float2fix7(val):
    return int(val*128.0)

def fix2float7(val):
    return val/128.0

packet = [0x00,float2fix7(0.5),0,0x32]

def fixToFloat(llsb, lsb, msb, mmsb):
        number = mmsb << 24
        number |= msb << 16
        number |= lsb << 8
        number |= llsb

        return float(number)/65536.0

def spi_writeread(data):
    #figure out how many bytes you are going to receive
    spi.cshigh = False

    spi.xfer(data)
        
    resp = spi.readbytes(4)
    
    voltage = fixToFloat(resp[3], resp[2], resp[1], resp[0])
    #receive the bytes
    spi.cshigh = True
    return voltage

def animate(i):
        global numSamples
        global xIncrement
        global packet
        global dropPacketConst
        global txt
        
	x = i%(xmax + 1)
	dataReady = False
	xar = []
	yar = []
	minVolt = sys.maxint
        maxVolt = 0
        prevy = 0
	while dataReady == False:
                y = spi_writeread(packet)
                if y==65535:
                        numPackets = 0
                        acc = 0
                        while numPackets <= (numSamples-1):
                                y = spi_writeread(packet)
                                prevy = y
                                if (y > maxVolt):
                                    maxVolt = y

                                if (y !=0 and y < minVolt):
                                    minVolt = y
                                acc += xIncrement
                                xar.append(acc)
                                yar.append(y)
                                numPackets += 1

                        print 
                        peakToPeak = maxVolt - minVolt
                        plotLim = numSamples - int(xMaxSlider.val *dropPacketConst)
                        line.set_data(xar[:plotLim], yar[:plotLim])
                        ax1.set_xlim(0, xmax * float(plotLim)/float(numSamples))
                        txt.set_text('Peak to Peak:'+ str(peakToPeak))
                        dataReady = True
        
	return line,

def updateAxes(x):
    global ymax

    ymax = yMaxSlider.val
    ax1.set_ylim(0, int(ymax))

    
#xMaxSlider.on_changed(updateAxes)
yMaxSlider.on_changed(updateAxes)

# Type: 0 is Sine, 1 is Square, 2 is Sawtooth
def fcn_gen(x):
    global packet
    frequency = int(freqSlider.val)
    amplitude = ampSlider.val
    #Set the type to above configuration
    if radio.value_selected == 'Sine':
        wType = 0  
    elif radio.value_selected== 'Square':
        wType = 1
    elif radio.value_selected == 'Sawtooth':
        wType = 2
    else:
        wType = 3

    packet[0] = wType
    packet[1] = float2fix7(amplitude)
    packet[2] = (frequency & 0xFFFF) >> 8
    packet[3] = (frequency & 0xFF)

    spi_writeread(packet)
    
freqSlider.on_changed(fcn_gen)
ampSlider.on_changed(fcn_gen)
radio.on_clicked(fcn_gen)

def save_file(x):
    global saveIndex
    if saveButton.value_selected == 'Save':
        path = 'plot'+str(saveIndex)+'.png'
        fig.savefig(path)
        saveIndex += 1

saveButton.on_clicked(save_file)


def spi_read():
        #figure out how many bytes you are going to receive
        spi.cshigh = False
        resp = spi.readbytes(4)

        voltage = fixToFloat(resp[3], resp[2], resp[1], resp[0])
        #receive the bytes
        spi.cshigh = True
        return voltage

if __name__ == "__main__":
    ani = animation.FuncAnimation(fig, animate, interval=interval_ms)
    fig.show()
